##############################################################################
#
# Copyright (c) 2002 Nik Kim <fafhrd@mindless.com> All Rights Reserved.
# 
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
#
##############################################################################

from Globals import InitializeClass
from AccessControl import ClassSecurityInfo
from Products.CMFCore.CMFCorePermissions import View, ModifyPortalContent
from Products.Formulator import Validator, Widget
from CMFField import CMFField

factory_type_information = (
    {   'id'             : 'Form CheckBoxField',
        'meta_type'      : 'CMF Form CheckBoxField',
        'description'    : """Form CheckBoxField""",
        'icon'           : 'CheckBoxField.gif',
        'product'        : 'CMFFormulator',
        'factory'        : 'manage_addCheckBoxField',
        'immediate_view' : 'ffield_chk_edit_form',
        'actions'        :
      ( { 'id'         : 'view',
          'name'       : 'View',
          'action'     : 'ffield_view',
          'permissions': (View,),
          'category'   : 'object',
          },
        {'id'         : 'edit',
         'name'       : 'Edit',
         'action'     : 'ffield_chk_edit_form',
         'permissions': (ModifyPortalContent,),
         'category'   : 'object',
         },
        {'id'         : 'metadata',
         'name'       : 'Metadata',
         'action'     : 'metadata_edit_form',
         'permissions': (ModifyPortalContent, ),
         'category'   : 'object',
          },
        )
        },
    )


class CMFCheckBoxField(CMFField):
    meta_type = 'CMF Form CheckBoxField'

    security = ClassSecurityInfo()

    extra = ''

    widget = Widget.CheckBoxWidgetInstance
    validator = Validator.BooleanValidatorInstance

    security.declarePublic(View, 'Extra')
    def Extra(self):
        """ """
        return self.extra

InitializeClass(CMFCheckBoxField)

def manage_addCheckBoxField(self, id, title="", REQUEST=None, **kwargs):
    """Add form to folder. """
    id = self._setObject(id, CMFCheckBoxField(id, title, **kwargs))
    
    if REQUEST is not None:
        return self.folder_contents( # XXX: ick!
            self, REQUEST, portal_status_message="CheckBoxField form added")

