##############################################################################
#
# Copyright (c) 2002 Nik Kim <fafhrd@mindless.com> All Rights Reserved.
# 
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
#
##############################################################################

from Globals import InitializeClass
from AccessControl import ClassSecurityInfo
from Products.CMFCore.CMFCorePermissions import View, ModifyPortalContent
from Products.Formulator import Validator, Widget
from CMFField import CMFField

try:
    _lo_attrs = 1
    from Products.CMFCore.LocaleAttributes import LocaleAttributes
except:
    _lo_attrs = 0
    class LocaleAttributes: pass

factory_type_information = (
    {   'id'             : 'Form MultiCheckBoxField',
        'meta_type'      : 'CMF Form MultiCheckBoxField',
        'description'    : """Form MultiCheckBoxField""",
        'icon'           : 'MultiCheckBoxField.gif',
        'product'        : 'CMFFormulator',
        'factory'        : 'manage_addMultiCheckBoxField',
        'immediate_view' : 'ffield_multi_edit_form',
        'actions'        :
      ( { 'id'         : 'view',
          'name'       : 'View',
          'action'     : 'ffield_view',
          'permissions': (View,),
          'category'   : 'object',
          },
        {'id'         : 'edit',
         'name'       : 'Edit',
         'action'     : 'ffield_multi_edit_form',
         'permissions': (ModifyPortalContent,),
         'category'   : 'object',
         },
        {'id'         : 'metadata',
         'name'       : 'Metadata',
         'action'     : 'metadata_edit_form',
         'permissions': (ModifyPortalContent, ),
         'category'   : 'object',
          },
        )
        },
    )


class CMFMultiCheckBoxField(CMFField):
    meta_type = 'CMF Form MultiCheckBoxField'

    security = ClassSecurityInfo()

    if _lo_attrs:
        __locale_attrs__ = {'items':[]}
        __locale_attrs__.update(CMFField.__locale_attrs__)
    else:
        items = []

    orientation = ''

    widget = Widget.MultiCheckBoxWidgetInstance
    validator = Validator.MultiSelectionValidatorInstance

    security.declarePublic(View, 'Extra')
    def Extra(self):
        """ """
        return self.extra

    security.declarePublic(View, 'Items')
    def Items(self):
        """ """
        items = self.items
        if (len(items) > 0) and (type(items[0]) != type(())):
            self.items = [(s, s) for s in items]
            items = self.items

        return items

    security.declarePublic(View, 'Orientation')
    def Orientation(self):
        """ """
        return self.orientation

InitializeClass(CMFMultiCheckBoxField)


def manage_addMultiCheckBoxField(self, id, title="", REQUEST=None, **kwargs):
    """Add form to folder. """
    id = self._setObject(id, CMFMultiCheckBoxField(id, title, **kwargs))
    
    if REQUEST is not None:
        return self.folder_contents( # XXX: ick!
            self, REQUEST,
            portal_status_message="MultiCheckBoxField form added")

