from xml.dom.minidom import parse


class NotTextNodeError:
    pass


def getTextFromNode(node):
    """
    scans through all children of node and gathers the
    text. if node has non-text child-nodes, then
    NotTextNodeError is raised.
    """
    t = ""
    for n in node.childNodes:
	if n.nodeType == n.TEXT_NODE:
	    t += n.nodeValue
	else:
	    raise NotTextNodeError
    return t


def nodeToDic(node):
    dic = {}
    for n in node.childNodes:
	if n.nodeType != n.ELEMENT_NODE:
	    continue
	if n.getAttribute("multiple") == "true":
	    l = []
	    for c in n.childNodes:
	        if c.nodeType != n.ELEMENT_NODE:
		    continue
		l.append(nodeToDic(c))
	        dic.update({n.nodeName.encode('latin-1'):l})
	    continue
        
	try:
	    text = getTextFromNode(n)
            try:
                if n.getAttribute("type"):
                    attr = n.getAttribute("type")
                    if attr == u'int':
                        text = int(text)
            except: pass
	except NotTextNodeError:
            # 'normal' node
            dic.update({n.nodeName.encode('latin-1'):nodeToDic(n)})
            continue

        # text node
        try:
            text = text.encode('latin-1')
        except: pass
        
        dic.update({n.nodeName.encode('latin-1'):text})
	continue
    return dic


def readData(filename):
    dom = parse(filename)
    return nodeToDic(dom)

def test():
    dic = readData("sample.xml")
    
    #print dic["Config"]["Name"]
    print dic
    #for item in dic["Config"]["Items"]:
    #    print "Item's Name:", item["Name"]
    #    print "Item's Value:", item["Value"]


if __name__ == '__main__':
    test()
